exercises/webpacker/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :users
  resources :tasks
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root 'welcome#index'
end

exercises/webpacker/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/webpacker/app/models/task.rb
# frozen_string_literal: true

class Task < ApplicationRecord
  validates :name, presence: true

  belongs_to :assigned_to, class_name: 'User', foreign_key: 'user_id'
end

exercises/webpacker/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  validates :name, presence: true
  validates :email, presence: true

  has_many :tasks
end

exercises/webpacker/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/webpacker/app/controllers/tasks_controller.rb
# frozen_string_literal: true

class TasksController < ApplicationController
  before_action :set_task, only: %i[show edit update destroy]

  def index
    @tasks = Task.all
  end

  def show; end

  def new
    @task = Task.new
  end

  def edit; end

  def create
    @task = Task.new(task_params)

    if @task.save
      redirect_to @task, notice: 'Task was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @task.update(task_params)
      redirect_to @task, notice: 'Task was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @task.destroy

    redirect_to tasks_url, notice: 'Task was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_task
    @task = Task.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def task_params
    params.require(:task).permit(:name, :description, :user_id, :status_id)
  end
end

exercises/webpacker/app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  before_action :set_user, only: %i[show edit update destroy]

  def index
    @search = User.ransack params[:q]

    @users = @search.result
  end

  def show
    @tasks = @user.tasks
  end

  def new
    @user = User.new
  end

  def edit; end

  def create
    @user = User.new(user_params)

    if @user.save
      redirect_to @user, notice: 'User was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @user.update(user_params)
      redirect_to @user, notice: 'User was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @user.destroy

    redirect_to users_url, notice: 'User was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_user
    @user = User.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def user_params
    params.require(:user).permit(:name, :email)
  end
end

exercises/webpacker/app/controllers/welcome_controller.rb
# frozen_string_literal: true

class WelcomeController < ApplicationController
  def index; end
end

exercises/webpacker/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/webpacker/app/helpers/users_helper.rb
# frozen_string_literal: true

module UsersHelper
end

exercises/webpacker/app/views/users/_filter.html.slim
.p-3.mb-3.bg-light
  = simple_form_for @search, method: 'get', wrapper: :filter_form, html: { class: 'd-flex form-row row-cols-1 row-cols-sm-2 row-cols-lg-3 row-cols-xl-4' }, url: url_for, defaults: { required: false } do |f|
    = f.input :name_cont, placeholder: 'Name'
    = f.input :email_cont, placeholder: 'Email'
    .col-auto.my-1.d-flex
      = f.button :submit, 'Search', class: 'btn-primary flex-grow-1 me-2'
      = link_to 'Reset', url_for, class: 'btn btn-outline-primary'

exercises/webpacker/app/views/users/_form.html.slim
= simple_form_for(@user) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :name
  = f.input :email

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/webpacker/app/views/users/edit.html.slim
= content_for :title do
  = 'Editing user'

== render 'form'

hr

.d-flex
  = link_to 'Show', @user, class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/webpacker/app/views/users/index.html.slim
= content_for :title do
  = 'Users'

= link_to 'New User', new_user_path, class: 'btn btn-primary'

= render 'filter'

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } Name
      th{ scope: :col } Email
      th

  tbody
    - @users.each_with_index do |user, i|
      tr
        th{ scope: :col } = i + 1
        td = user.name
        td = user.email
        td.d-flex
          .me-4 = link_to 'Show', user
          .me-4 = link_to 'Edit', edit_user_path(user)
          = link_to 'Destroy', user, data: { confirm: 'Are you sure?' }, method: :delete

exercises/webpacker/app/views/users/new.html.slim
= content_for :title do
  = 'New user'

== render 'form'

hr

= link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/webpacker/app/views/users/show.html.slim
= content_for :title do
  = @user.name

p
  = @user.email

- if @tasks.any?
  h4 Tasks:

  table.table.table-striped.table-hover.mb-5
    thead
      tr
        th{ scope: :col } #
        th{ scope: :col } Name

    tbody
      - @tasks.each_with_index do |task, i|
        tr
          th{ scope: :col } = i + 1
          td = link_to task.name, task

hr

.d-flex
  = link_to 'Edit', edit_user_path(@user), class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'